VTK: vtkSimpleMotionBlurPass Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkSimpleMotionBlurPass Class Reference

Avergae frames to simulate motion blur. More...

`#include <vtkSimpleMotionBlurPass.h>`

Inheritance diagram for vtkSimpleMotionBlurPass:
[legend]
Collaboration diagram for vtkSimpleMotionBlurPass:
[legend]

## Public Types
typedef vtkDepthImageProcessingPass | Superclass
Public Types inherited from vtkDepthImageProcessingPass
typedef vtkImageProcessingPass | Superclass
Public Types inherited from vtkImageProcessingPass
typedef vtkOpenGLRenderPass | Superclass
Public Types inherited from vtkOpenGLRenderPass
typedef vtkRenderPass | Superclass
Public Types inherited from vtkRenderPass
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkSimpleMotionBlurPass * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | Render (const vtkRenderState *s) override
| Perform rendering according to a render state `s`. More...
void | ReleaseGraphicsResources (vtkWindow *w) override
| Release graphics resources and ask components to release their own resources. More...
virtual void | SetDepthFormat (int)
| Set the format to use for the depth texture e.g. More...
virtual void | SetColorFormat (int)
| Set the format to use for the color texture vtkTextureObject::Float16 vtkTextureObject::Float32 and vtkTextureObject::Fixed8 are supported. More...
virtual vtkTextureObject * | GetDepthTexture ()
virtual vtkTextureObject * | GetColorTexture ()
virtual int | GetSubFrames ()
| Set the number of sub frames for doing motion blur. More...
virtual void | SetSubFrames (int subFrames)
| Set the number of sub frames for doing motion blur. More...
Public Member Functions inherited from vtkDepthImageProcessingPass
vtkDepthImageProcessingPass * | NewInstance () const
Public Member Functions inherited from vtkImageProcessingPass
vtkImageProcessingPass * | NewInstance () const
virtual vtkRenderPass * | GetDelegatePass ()
| Delegate for rendering the image to be processed. More...
virtual void | SetDelegatePass (vtkRenderPass *delegatePass)
| Delegate for rendering the image to be processed. More...
Public Member Functions inherited from vtkOpenGLRenderPass
vtkOpenGLRenderPass * | NewInstance () const
virtual bool | SetShaderParameters (vtkShaderProgram *program, vtkAbstractMapper *mapper, vtkProp *prop, vtkOpenGLVertexArrayObject *VAO=nullptr)
| Update the uniforms of the shader program. More...
virtual vtkMTimeType | GetShaderStageMTime ()
| For multi-stage render passes that need to change shader code during a single pass, use this method to notify a mapper that the shader needs to be rebuilt (rather than reuse the last cached shader. More...
virtual void | SetActiveDrawBuffers (unsigned int)
| Number of active draw buffers. More...
virtual unsigned int | GetActiveDrawBuffers ()
virtual bool | PreReplaceShaderValues (std::string &vertexShader, std::string &geometryShader, std::string &fragmentShader, vtkAbstractMapper *mapper, vtkProp *prop)
| Use vtkShaderProgram::Substitute to replace. More...
virtual bool | PostReplaceShaderValues (std::string &vertexShader, std::string &geometryShader, std::string &fragmentShader, vtkAbstractMapper *mapper, vtkProp *prop)
| Use vtkShaderProgram::Substitute to replace. More...
Public Member Functions inherited from vtkRenderPass
vtkRenderPass * | NewInstance () const
virtual int | GetNumberOfRenderedProps ()
| Number of props rendered at the last Render call. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkSimpleMotionBlurPass * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkSimpleMotionBlurPass * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkDepthImageProcessingPass
static vtkTypeBool | IsTypeOf (const char *type)
static vtkDepthImageProcessingPass * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkImageProcessingPass
static vtkTypeBool | IsTypeOf (const char *type)
static vtkImageProcessingPass * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkOpenGLRenderPass
static vtkTypeBool | IsTypeOf (const char *type)
static vtkOpenGLRenderPass * | SafeDownCast (vtkObjectBase *o)
static vtkInformationObjectBaseVectorKey * | RenderPasses ()
| Key containing information about the current pass. More...
Static Public Member Functions inherited from vtkRenderPass
static vtkTypeBool | IsTypeOf (const char *type)
static vtkRenderPass * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkSimpleMotionBlurPass ()
| Default constructor. More...
| ~vtkSimpleMotionBlurPass () override
| Destructor. More...
Protected Member Functions inherited from vtkDepthImageProcessingPass
| vtkDepthImageProcessingPass ()
| Default constructor. More...
| ~vtkDepthImageProcessingPass () override
| Destructor. More...
virtual void | RenderDelegate (const vtkRenderState *s, int width, int height, int newWidth, int newHeight, vtkOpenGLFramebufferObject *fbo, vtkTextureObject *colortarget, vtkTextureObject *depthtarget)
| Render delegate with a image of different dimensions than the original one. More...
void | ReadWindowSize (const vtkRenderState *s)
| Read parent size - for sake of code clarity This function is generic, can be useful in multiple image-based rendering classes. More...
Protected Member Functions inherited from vtkImageProcessingPass
| vtkImageProcessingPass ()
| Default constructor. More...
| ~vtkImageProcessingPass () override
| Destructor. More...
void | RenderDelegate (const vtkRenderState *s, int width, int height, int newWidth, int newHeight, vtkOpenGLFramebufferObject *fbo, vtkTextureObject *target)
| Render delegate with a image of different dimensions than the original one. More...
Protected Member Functions inherited from vtkOpenGLRenderPass
| vtkOpenGLRenderPass ()
| ~vtkOpenGLRenderPass () override
void | PreRender (const vtkRenderState *s)
| Call before rendering to update the actors' information keys. More...
void | PostRender (const vtkRenderState *s)
| Call after rendering to clean up the actors' information keys. More...
Protected Member Functions inherited from vtkRenderPass
| vtkRenderPass ()
| Default constructor. More...
| ~vtkRenderPass () override
| Destructor. More...
void | UpdateCamera (vtkRenderer *renderer)
| Call UpdateCamera() on Renderer. More...
void | ClearLights (vtkRenderer *renderer)
| Call ClearLights() on Renderer. More...
void | UpdateLightGeometry (vtkRenderer *renderer)
| Call UpdateLightGeometry() on Renderer. More...
void | UpdateLights (vtkRenderer *renderer)
| Call UpdateLights() on Renderer. More...
void | UpdateGeometry (vtkRenderer *renderer, vtkFrameBufferObjectBase *fbo=nullptr)
| Call UpdateGeometry() on Renderer. More...
void | SetLastRenderingUsedDepthPeeling (vtkRenderer *renderer, bool value)
| Modify protected member LastRenderingUsedDepthPeeling on Renderer. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkOpenGLFramebufferObject * | FrameBufferObject
| Graphics resources. More...
vtkTextureObject * | ColorTexture
vtkTextureObject * | AccumulationTexture [2]
vtkTextureObject * | DepthTexture
int | DepthFormat
int | ColorFormat
int | SubFrames
int | CurrentSubFrame
int | ActiveAccumulationTexture
vtkOpenGLHelper * | BlendProgram
int | ViewportX
| Cache viewport values for depth peeling. More...
int | ViewportY
| Cache viewport values for depth peeling. More...
int | ViewportWidth
| Cache viewport values for depth peeling. More...
int | ViewportHeight
| Cache viewport values for depth peeling. More...
Protected Attributes inherited from vtkDepthImageProcessingPass
int | Origin [2]
int | Width
int | Height
int | W
int | H
int | ExtraPixels
Protected Attributes inherited from vtkImageProcessingPass
vtkRenderPass * | DelegatePass
Protected Attributes inherited from vtkOpenGLRenderPass
unsigned int | ActiveDrawBuffers = 0
Protected Attributes inherited from vtkRenderPass
int | NumberOfRenderedProps
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

Avergae frames to simulate motion blur.

A slow and simple approach that simply renders multiple frames and accumulates them before displaying them. As such it causes the render process to be SubFrames times slower than normal but handles all types of motion correctly as it is actually rendering all the sub frames.

See also
  vtkRenderPass

Online Examples:

Tests:
  vtkSimpleMotionBlurPass (Tests)

Definition at line 41 of file vtkSimpleMotionBlurPass.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkDepthImageProcessingPass vtkSimpleMotionBlurPass::Superclass

Definition at line 45 of file vtkSimpleMotionBlurPass.h.

## Constructor & Destructor Documentation

## ◆ vtkSimpleMotionBlurPass()

vtkSimpleMotionBlurPass::vtkSimpleMotionBlurPass | ( |  | ) |
| protected

Default constructor.

DelegatePass is set to NULL.

## ◆ ~vtkSimpleMotionBlurPass()

vtkSimpleMotionBlurPass::~vtkSimpleMotionBlurPass | ( |  | ) |
| overrideprotected

Destructor.

## Member Function Documentation

## ◆ New()

static vtkSimpleMotionBlurPass* vtkSimpleMotionBlurPass::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkSimpleMotionBlurPass::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkSimpleMotionBlurPass::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkDepthImageProcessingPass.

## ◆ SafeDownCast()

static vtkSimpleMotionBlurPass* vtkSimpleMotionBlurPass::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkSimpleMotionBlurPass::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkDepthImageProcessingPass.

## ◆ NewInstance()

vtkSimpleMotionBlurPass* vtkSimpleMotionBlurPass::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkSimpleMotionBlurPass::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkDepthImageProcessingPass.

## ◆ Render()

void vtkSimpleMotionBlurPass::Render | ( | const vtkRenderState * | s | ) |
| overridevirtual

Perform rendering according to a render state `s`.

Precondition
  s_exists: s!=0

Implements vtkRenderPass.

## ◆ ReleaseGraphicsResources()

void vtkSimpleMotionBlurPass::ReleaseGraphicsResources | ( | vtkWindow * | w | ) |
| overridevirtual

Release graphics resources and ask components to release their own resources.

Precondition
  w_exists: w!=0

Reimplemented from vtkImageProcessingPass.

## ◆ GetSubFrames()

virtual int vtkSimpleMotionBlurPass::GetSubFrames | ( |  | ) |
| virtual

Set the number of sub frames for doing motion blur.

Once this is set greater than one, you will no longer see a new frame for every Render(). If you set this to five, you will need to do five Render() invocations before seeing the result. This isn't very impressive unless something is changing between the Renders. Changing this value may reset the current subframe count.

## ◆ SetSubFrames()

virtual void vtkSimpleMotionBlurPass::SetSubFrames | ( | int | subFrames | ) |
| virtual

Set the number of sub frames for doing motion blur.

Once this is set greater than one, you will no longer see a new frame for every Render(). If you set this to five, you will need to do five Render() invocations before seeing the result. This isn't very impressive unless something is changing between the Renders. Changing this value may reset the current subframe count.

## ◆ SetDepthFormat()

virtual void vtkSimpleMotionBlurPass::SetDepthFormat | ( | int |  | ) |
| virtual

Set the format to use for the depth texture e.g.

vtkTextureObject::Float32

## ◆ SetColorFormat()

virtual void vtkSimpleMotionBlurPass::SetColorFormat | ( | int |  | ) |
| virtual

Set the format to use for the color texture vtkTextureObject::Float16 vtkTextureObject::Float32 and vtkTextureObject::Fixed8 are supported.

Fixed8 is the default.

## ◆ GetDepthTexture()

virtual vtkTextureObject* vtkSimpleMotionBlurPass::GetDepthTexture | ( |  | ) |
| virtual

## ◆ GetColorTexture()

virtual vtkTextureObject* vtkSimpleMotionBlurPass::GetColorTexture | ( |  | ) |
| virtual

## Member Data Documentation

## ◆ FrameBufferObject

vtkOpenGLFramebufferObject* vtkSimpleMotionBlurPass::FrameBufferObject
| protected

Graphics resources.

Definition at line 108 of file vtkSimpleMotionBlurPass.h.

## ◆ ColorTexture

vtkTextureObject* vtkSimpleMotionBlurPass::ColorTexture
| protected

Definition at line 109 of file vtkSimpleMotionBlurPass.h.

## ◆ AccumulationTexture

vtkTextureObject* vtkSimpleMotionBlurPass::AccumulationTexture[2]
| protected

Definition at line 110 of file vtkSimpleMotionBlurPass.h.

## ◆ DepthTexture

vtkTextureObject* vtkSimpleMotionBlurPass::DepthTexture
| protected

Definition at line 111 of file vtkSimpleMotionBlurPass.h.

## ◆ ViewportX

int vtkSimpleMotionBlurPass::ViewportX
| protected

Cache viewport values for depth peeling.

Definition at line 117 of file vtkSimpleMotionBlurPass.h.

## ◆ ViewportY

int vtkSimpleMotionBlurPass::ViewportY
| protected

Cache viewport values for depth peeling.

Definition at line 118 of file vtkSimpleMotionBlurPass.h.

## ◆ ViewportWidth

int vtkSimpleMotionBlurPass::ViewportWidth
| protected

Cache viewport values for depth peeling.

Definition at line 119 of file vtkSimpleMotionBlurPass.h.

## ◆ ViewportHeight

int vtkSimpleMotionBlurPass::ViewportHeight
| protected

Cache viewport values for depth peeling.

Definition at line 120 of file vtkSimpleMotionBlurPass.h.

## ◆ DepthFormat

int vtkSimpleMotionBlurPass::DepthFormat
| protected

Definition at line 123 of file vtkSimpleMotionBlurPass.h.

## ◆ ColorFormat

int vtkSimpleMotionBlurPass::ColorFormat
| protected

Definition at line 124 of file vtkSimpleMotionBlurPass.h.

## ◆ SubFrames

int vtkSimpleMotionBlurPass::SubFrames
| protected

Definition at line 126 of file vtkSimpleMotionBlurPass.h.

## ◆ CurrentSubFrame

int vtkSimpleMotionBlurPass::CurrentSubFrame
| protected

Definition at line 127 of file vtkSimpleMotionBlurPass.h.

## ◆ ActiveAccumulationTexture

int vtkSimpleMotionBlurPass::ActiveAccumulationTexture
| protected

Definition at line 128 of file vtkSimpleMotionBlurPass.h.

## ◆ BlendProgram

vtkOpenGLHelper* vtkSimpleMotionBlurPass::BlendProgram
| protected

Definition at line 129 of file vtkSimpleMotionBlurPass.h.

The documentation for this class was generated from the following file:

- Rendering/OpenGL2/vtkSimpleMotionBlurPass.h